import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkSiteTime, ThinkSiteTimeParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkSiteTime(params: ThinkSiteTimeParam) {
  const res = await request.get<ApiResult<PageResult<ThinkSiteTime>>>(
    THINK_API_URL + '/think/think-site-time/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkSiteTime(params?: ThinkSiteTimeParam) {
  const res = await request.get<ApiResult<ThinkSiteTime[]>>(
    THINK_API_URL + '/think/think-site-time',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkSiteTime(data: ThinkSiteTime) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-site-time',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkSiteTime(data: ThinkSiteTime) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-site-time',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkSiteTime(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-site-time/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkSiteTime(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-site-time/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkSiteTime(id: number) {
  const res = await request.get<ApiResult<ThinkSiteTime>>(
    THINK_API_URL + '/think/think-site-time/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
